package io.accumulatenetwork.sdk.generated.protocol;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import io.accumulatenetwork.sdk.protocol.Marshallable;
import io.accumulatenetwork.sdk.protocol.Url;
import io.accumulatenetwork.sdk.support.Marshaller;
import io.accumulatenetwork.sdk.support.serializers.HexDeserializer;
import io.accumulatenetwork.sdk.support.serializers.HexSerializer;
// UnionType: 
// UnionValue: 

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("ValidatorInfo")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class ValidatorInfo implements Marshallable {
	private byte[] publicKey;
	private byte[] publicKeyHash;
	private Url operator;
	private ValidatorPartitionInfo[] partitions;

    //
	@JsonDeserialize(using = HexDeserializer.class)
	public byte[] getPublicKey() {
	    return publicKey;
	}
	@JsonSerialize(using = HexSerializer.class)
	public void setPublicKey(final byte[] value) {
	    this.publicKey = value;
	}

	public ValidatorInfo publicKey(final byte[] value) {
	    setPublicKey(value);
	    return this;
	}
	public ValidatorInfo publicKey(final String value) {
		try {
			setPublicKey(io.accumulatenetwork.sdk.commons.codec.binary.Hex.decodeHex(value));
		} catch (io.accumulatenetwork.sdk.commons.codec.DecoderException e) {
			throw new RuntimeException(e);
		}
	    return this;
	}
	@JsonDeserialize(using = HexDeserializer.class)
	public byte[] getPublicKeyHash() {
	    return publicKeyHash;
	}
	@JsonSerialize(using = HexSerializer.class)
	public void setPublicKeyHash(final byte[] value) {
	    this.publicKeyHash = value;
	}

	public ValidatorInfo publicKeyHash(final byte[] value) {
	    setPublicKeyHash(value);
	    return this;
	}
	public ValidatorInfo publicKeyHash(final String value) {
		try {
			setPublicKeyHash(io.accumulatenetwork.sdk.commons.codec.binary.Hex.decodeHex(value));
		} catch (io.accumulatenetwork.sdk.commons.codec.DecoderException e) {
			throw new RuntimeException(e);
		}
	    return this;
	}
	public Url getOperator() {
	    return operator;
	}
	public void setOperator(final Url value) {
	    this.operator = value;
	}

	public ValidatorInfo operator(final Url value) {
	    setOperator(value);
	    return this;
	}
	public ValidatorInfo operator(final String value) {
	    setOperator(Url.toAccURL(value));
	    return this;
	}
	public ValidatorPartitionInfo[] getPartitions() {
	    return partitions;
	}
	public void setPartitions(final ValidatorPartitionInfo[] value) {
	    this.partitions = value;
	}

	public ValidatorInfo partitions(final ValidatorPartitionInfo[] value) {
	    setPartitions(value);
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        if (!(this.publicKey == null || this.publicKey.length == 0)) {
            marshaller.writeBytes(1, this.publicKey);
        }
        if (!(this.publicKeyHash == null || this.publicKeyHash.length == 0)) {
            marshaller.writeHash(2, this.publicKeyHash);
        }
        if (!(this.operator == null)) {
            marshaller.writeUrl(3, this.operator);
        }
        if (!(this.partitions == null)) {
            marshaller.writeValue(4, partitions);
        }
        return marshaller.array();
    }
}
